﻿using C1.Win.Ribbon;
using C1.Win.C1Schedule;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Threading;

namespace WindowsFormsApp2
{
    public partial class Form1 : C1RibbonForm
    {
        public Form1()
        {
            InitializeComponent();

            this.c1Schedule1.ViewType = ScheduleViewEnum.TimeLineView;

            this.c1Schedule1.CalendarInfo.FirstDate = DateTime.Today.AddMonths(-1);
            this.c1Schedule1.CalendarInfo.LastDate = DateTime.Today.AddMonths(+1);

            DateTime[] arrDates = new DateTime[1];
            arrDates[0] = DateTime.Today.AddDays(-10);
            this.c1Schedule1.ShowDates(arrDates, this.c1Schedule1.ViewType);

        }

        private void ShowMyDates() {

            DateTime[] arrDates = new DateTime[1];

            // To scroll the schedule to the center, initially calling ShowDates for the single Date in the center of the date interval helps as a workaround
            //arrDates[0] = DateTime.Today;
            //this.c1Schedule1.ShowDates(arrDates, this.c1Schedule1.ViewType);
            arrDates = new DateTime[7];
            int intIndex = 0;
            for (DateTime dtAdd = DateTime.Today.AddDays(-3); dtAdd <= DateTime.Today.AddDays(3); dtAdd = dtAdd.AddDays(1))
            {
                arrDates[intIndex] = dtAdd;
                intIndex++;
            }
            c1Schedule1.BeginUpdate();
            c1Schedule1.ShowDates(arrDates, this.c1Schedule1.ViewType);
            c1Schedule1.EndUpdate();

            //"Refresh" is required. Otherwise "ScrollSize" is 0.
            //this.c1Schedule1.Refresh();
            //this.c1Schedule1.ScrollPosition = new Point(-1 * this.c1Schedule1.ScrollSize.Width / 2, 0);
        }

        private void ribbonButton1_Click(object sender, EventArgs e)
        {
            ShowMyDates();
        }

        private void ribbonButtonScroll_Click(object sender, EventArgs e)
        {
            
            c1Schedule1.GoToDate(DateTime.Now);
            ShowMyDates();
            c1Schedule1.Refresh();
            c1Schedule1.EnsureVisibleTime(DateTime.Now.Subtract(c1Schedule1.SelectedDates[0]));
        }
    }
}
